from abc import ABC, abstractproperty
from typing import Any, Dict

from xcnt.sqlalchemy.search.api_gateway_crd.generator import Generator


class BaseTypeMixin(ABC):
    generator: Generator

    @abstractproperty
    def scalar_type_name(self) -> str:
        pass

    @property
    def scalar_type_key(self) -> str:
        return "scalar"

    def to_api_gateway_type(self) -> Dict[str, Any]:
        return {self.scalar_type_key: self.scalar_type_name}
