from abc import ABC, abstractproperty
from enum import Enum
from typing import Any, Dict, NamedTuple, Type

from xcnt.sqlalchemy.search.api_gateway_crd.api_gateway_type_mixin.base import BaseTypeMixin
from xcnt.sqlalchemy.search.api_gateway_crd.fields import util


class EnumFieldReference(NamedTuple):
    enum: Type[Enum]


class EnumTypeMixin(BaseTypeMixin, ABC):
    @abstractproperty
    def enum(self) -> Type[Enum]:
        pass

    @property
    def current_collection_key(self) -> Any:
        return EnumFieldReference(enum=self.enum)

    @property
    def scalar_type_name(self) -> str:
        return self.enum_reference_name

    @property
    def scalar_type_key(self) -> str:
        return "enumRef"

    @property
    def enum_reference_name(self) -> str:
        return self.enum_reference["metadata"]["name"]

    @property
    def enum_reference(self) -> Dict[str, Any]:
        enum_reference = util.api_spec_for(self.enum, generator=self.generator)
        assert enum_reference is not None
        return enum_reference
