from __future__ import annotations

from abc import ABC
from functools import cached_property
from typing import TYPE_CHECKING, Type

from xcnt.sqlalchemy.search.query.resource_base import ResourceBase

if TYPE_CHECKING:
    from xcnt.sqlalchemy.search.api_gateway_crd.generator import Generator


class BaseResourceGenerator(ABC):
    def __init__(self, resource: Type[ResourceBase], generator: Generator):
        self.resource = resource
        self.generator = generator

    @cached_property
    def resource_instance(self) -> ResourceBase:
        return self.resource()
