from __future__ import annotations

from abc import abstractmethod
from typing import Any, Dict, Generic, Optional, TypeVar

from xcnt.sqlalchemy.search.api_gateway_crd.fields.api_gateway_converter_plugin import APIGatewayConverterPlugin
from xcnt.sqlalchemy.search.fields.base import BaseField

AbstractNestedTarget = TypeVar("AbstractNestedTarget", bound=BaseField)


class AbstractNestedConverter(APIGatewayConverterPlugin[AbstractNestedTarget], Generic[AbstractNestedTarget]):
    def to_api_gateway_part(self) -> Optional[Dict[str, Any]]:
        reference = self._generate_reference_api_gateway_part()
        if self.item.description is not None:
            reference["description"] = self.item.description
        return reference

    @abstractmethod
    def _generate_reference_api_gateway_part(self) -> Dict[str, Any]:
        pass
