from __future__ import annotations

from typing import Any, Dict

from xcnt.sqlalchemy.search.api_gateway_crd.fields.abstract_nested import AbstractNestedConverter
from xcnt.sqlalchemy.search.api_gateway_crd.fields.util import api_gateway_field_query
from xcnt.sqlalchemy.search.api_gateway_crd.having_reference import HavingReference
from xcnt.sqlalchemy.search.fields.abstract_nested_having import AbstractNestedHaving


class AbstractNestedHavingConverter(AbstractNestedConverter[AbstractNestedHaving]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, AbstractNestedHaving)

    def _generate_reference_api_gateway_part(self) -> Dict[str, Any]:
        nested_having = api_gateway_field_query.api_spec_for(HavingReference(self.item.nested_resource), self.generator)
        assert nested_having is not None
        return nested_having
