from __future__ import annotations

from typing import Any, Dict

from xcnt.sqlalchemy.search.api_gateway_crd.fields.abstract_nested import AbstractNestedConverter
from xcnt.sqlalchemy.search.api_gateway_crd.fields.util import api_gateway_field_query
from xcnt.sqlalchemy.search.api_gateway_crd.nested_resource import NestedResource
from xcnt.sqlalchemy.search.fields.abstract_nested_resource import AbstractNestedResource


class AbstractNestedResourceConverter(AbstractNestedConverter[AbstractNestedResource]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, AbstractNestedResource)

    def _generate_reference_api_gateway_part(self) -> Dict[str, Any]:
        nested_resource = api_gateway_field_query.api_spec_for(
            NestedResource(self.item.nested_resource), self.generator
        )
        assert nested_resource is not None
        return nested_resource
