from __future__ import annotations

from abc import abstractclassmethod, abstractmethod
from typing import TYPE_CHECKING, Any, Dict, Generic, Optional, TypeVar

if TYPE_CHECKING:
    from xcnt.sqlalchemy.search.api_gateway_crd.generator import Generator

ConvertElement = TypeVar("ConvertElement")


class APIGatewayConverterPlugin(Generic[ConvertElement]):
    def __init__(self, item: ConvertElement, generator: Generator):
        self.item = item
        self.generator = generator

    @abstractclassmethod
    def supports(cls, entity: Any) -> bool:
        pass

    @abstractmethod
    def to_api_gateway_part(self) -> Optional[Dict[str, Any]]:
        pass
