from __future__ import annotations

from typing import Any, Dict, Optional

from xcnt.sqlalchemy.search.api_gateway_crd.fields.api_gateway_converter_plugin import APIGatewayConverterPlugin
from xcnt.sqlalchemy.search.api_gateway_crd.fields.util import api_spec_for
from xcnt.sqlalchemy.search.fields import ComputedField


class ComputedFieldConverter(APIGatewayConverterPlugin[ComputedField]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, ComputedField)

    def to_api_gateway_part(self) -> Optional[Dict[str, Any]]:
        return api_spec_for(self.item.field, self.generator)
