from typing import Any, Dict, Optional

from xcnt.sqlalchemy.search.api_gateway_crd.fields.api_gateway_converter_plugin import APIGatewayConverterPlugin
from xcnt.sqlalchemy.search.api_gateway_crd.fields.util import api_spec_for
from xcnt.sqlalchemy.search.fields import JoinedModel


class JoinedModelConverter(APIGatewayConverterPlugin[JoinedModel]):
    @classmethod
    def supports(cls, entity: Any) -> bool:
        return isinstance(entity, JoinedModel)

    def to_api_gateway_part(self) -> Optional[Dict[str, Any]]:
        return api_spec_for(self.item.wraps, self.generator)
