from enum import Enum
from typing import Any, Type

from xcnt.sqlalchemy.search import fields
from xcnt.sqlalchemy.search.api_gateway_crd import api_gateway_type_mixin
from xcnt.sqlalchemy.search.api_gateway_crd.fields.scalar.argument_collection import ScalarArgumentCollectionConverter


class EnumConverter(api_gateway_type_mixin.Enum, ScalarArgumentCollectionConverter[fields.Enum]):
    field_class = fields.Enum

    @property
    def converted_object(self) -> Any:
        return (super().converted_object, self.enum)

    @property
    def enum(self) -> Type[Enum]:
        return self.item.field.enum
