from typing import Any, Dict, Optional

from xcnt.sqlalchemy.search.api_gateway_crd.fields import APIGatewayConverterPlugin
from xcnt.sqlalchemy.search.api_gateway_crd.fields.scalar.filter.request import FilterRequest
from xcnt.sqlalchemy.search.parser.filter_parser import FilterFieldParser
from xcnt.sqlalchemy.search.parser.filters import FilterClass


def get_filter_for(name: str) -> Optional[FilterClass]:
    return FilterFieldParser.function_mapping.get(name, None)


class FilterConverter(APIGatewayConverterPlugin[FilterRequest]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        if isinstance(entity, FilterRequest):
            filter_parser = get_filter_for(entity.filter_name)
            return filter_parser is not None
        return False

    def to_api_gateway_part(self) -> Optional[Dict[str, Any]]:
        type_value = {
            "type": self.item.type_dict,
            "required": False,
            "in": "query",
        }
        return type_value
