from __future__ import annotations

from typing import Any, Type

from xcnt.sqlalchemy.search.api_gateway_crd.abstract_reference_converter import AbstractReferenceConverter
from xcnt.sqlalchemy.search.api_gateway_crd.having_reference import HavingReference
from xcnt.sqlalchemy.search.query.resource_having import AbstractHavingBaseClass


class HavingReferenceConverter(AbstractReferenceConverter[HavingReference, AbstractHavingBaseClass]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, HavingReference)

    @property
    def target(self) -> Type[AbstractHavingBaseClass]:
        return self.item.having
