from abc import ABC, abstractproperty
from typing import Any, Dict

AND_OR_ARGUMENTS = ("_and", "_or")
UUID_ARGUMENTS = ("_oneOf", "_notOf")


class ResourceFieldsMixin(ABC):
    @abstractproperty
    def parameter_location(self) -> str:
        pass

    @abstractproperty
    def collection_name(self) -> str:
        pass

    def add_self_nested_fields(self, collection_arguments: Dict[str, Any]) -> Dict[str, Any]:
        for argument in AND_OR_ARGUMENTS:
            collection_arguments[argument] = self.render_self_nested_field()
        return collection_arguments

    def render_self_nested_field(self) -> Dict[str, Any]:
        return {
            "in": self.parameter_location,
            "type": {"object": False, "list": True, "argumentCollectionRef": self.collection_name},
        }

    def add_self_uuid_fields(self, collection_arguments: Dict[str, Any]) -> Dict[str, Any]:
        for argument in UUID_ARGUMENTS:
            collection_arguments[argument] = self.render_uuid_field()
        return collection_arguments

    def render_uuid_field(self) -> Dict[str, Any]:
        return {
            "in": self.parameter_location,
            "type": {"object": False, "list": True, "scalar": "uuid"},
        }
