from __future__ import annotations

from typing import Any, Dict

from xcnt.sqlalchemy.search.apispec.fields.openapi_converter_plugin import OpenAPIConverterPlugin
from xcnt.sqlalchemy.search.fields import ComputedField


class ComputedFieldConverter(OpenAPIConverterPlugin[ComputedField]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, ComputedField)

    def to_openapi(self) -> Dict[str, Any]:
        return self.converter.build_field(self.item.field)
