from __future__ import annotations

from typing import Any, Dict

from xcnt.sqlalchemy.search.apispec.fields.openapi_converter_plugin import OpenAPIConverterPlugin
from xcnt.sqlalchemy.search.query import FieldGroup


class FieldGroupConverter(OpenAPIConverterPlugin[FieldGroup]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, FieldGroup)

    def to_openapi(self) -> Dict[str, Any]:
        field_group_name = self.item.__class__.__name__
        assert field_group_name is not None
        reference = self.converter.resolve_reference_field(field_group_name)
        if self.item.description is not None:
            reference["description"] = self.item.description
        return reference
