from abc import abstractproperty
from typing import Any, Dict, Generic, Optional, Type, TypeVar

from xcnt.sqlalchemy.search.apispec.fields.function_scalar_base import FunctionScalarBaseConverter
from xcnt.sqlalchemy.search.fields.function.base_function import BaseFunctionField

FunctionField = TypeVar("FunctionField", bound=BaseFunctionField)


class FunctionFieldConverter(FunctionScalarBaseConverter[FunctionField], Generic[FunctionField]):
    field_class: Type[FunctionField]

    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, self.field_class)

    @abstractproperty
    def type_name(self) -> str:
        pass

    @property
    def type_format(self) -> Optional[str]:
        return None

    @property
    def type_dict(self) -> Dict[str, Any]:
        type_dict = {
            "type": self.type_name,
        }
        if self.type_format is not None:
            type_dict["format"] = self.type_format

        return type_dict

    def to_openapi(self) -> Dict[str, Any]:
        openapi_spec = self.type_dict
        if self.item.description is not None:
            openapi_spec["description"] = self.item.description
        return openapi_spec
