from enum import Enum
from typing import Type

from xcnt.sqlalchemy.search import fields
from xcnt.sqlalchemy.search.apispec import openapi_type_mixin
from xcnt.sqlalchemy.search.apispec.fields.function.base import FunctionFieldConverter


class EnumConverter(openapi_type_mixin.Enum, FunctionFieldConverter[fields.EnumFunction]):
    field_class = fields.EnumFunction

    @property
    def enum(self) -> Type[Enum]:
        return self.item.enum
