from abc import ABC
from typing import Any, Generic, Type, TypeVar, Union

from xcnt.sqlalchemy.search.apispec import openapi_type_mixin
from xcnt.sqlalchemy.search.apispec.fields.openapi_converter_plugin import OpenAPIConverterPlugin
from xcnt.sqlalchemy.search.fields.function.base_function import BaseFunctionField
from xcnt.sqlalchemy.search.fields.scalar.base_scalar import BaseScalarField

ScalarFunctionField = TypeVar("ScalarFunctionField", bound=Union[BaseScalarField, BaseFunctionField])


class FunctionScalarBaseConverter(
    openapi_type_mixin.Base, OpenAPIConverterPlugin[ScalarFunctionField], Generic[ScalarFunctionField], ABC
):
    field_class: Type[ScalarFunctionField]

    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, self.field_class)
