from __future__ import annotations

from typing import Any, Dict

from xcnt.sqlalchemy.search.apispec.fields.openapi_converter_plugin import OpenAPIConverterPlugin
from xcnt.sqlalchemy.search.apispec.fields.util import get_for
from xcnt.sqlalchemy.search.fields.joined_model import JoinedModel


class JoinedModelConverter(OpenAPIConverterPlugin[JoinedModel]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, JoinedModel)

    def to_openapi(self) -> Dict[str, Any]:
        converter = get_for(self.item.wraps)
        converter_instance = converter(self.item.wraps, self.converter)
        return converter_instance.to_openapi()
