from __future__ import annotations

from typing import Any, Dict

from xcnt.sqlalchemy.search.apispec.fields.openapi_converter_plugin import OpenAPIConverterPlugin
from xcnt.sqlalchemy.search.fields.abstract_nested import AbstractNested


class NestedConverter(OpenAPIConverterPlugin[AbstractNested]):
    @classmethod
    def supports(self, entity: Any) -> bool:
        return isinstance(entity, AbstractNested)

    def to_openapi(self) -> Dict[str, Any]:
        reference = self.converter.resolve_nested_field(self.item.nested_resource.__name__)
        if self.item.description is not None:
            reference["description"] = self.item.description
        return reference
