from __future__ import annotations

from abc import abstractclassmethod, abstractmethod
from typing import TYPE_CHECKING, Any, Dict, Generic, TypeVar

if TYPE_CHECKING:
    from xcnt.sqlalchemy.search.apispec.openapi_converter import OpenAPIConverter

ConvertElement = TypeVar("ConvertElement")


class OpenAPIConverterPlugin(Generic[ConvertElement]):
    def __init__(self, item: ConvertElement, open_api_converter: OpenAPIConverter):
        self.item = item
        self.converter = open_api_converter

    @abstractclassmethod
    def supports(cls, entity: Any) -> bool:
        pass

    @abstractmethod
    def to_openapi(self) -> Dict[str, Any]:
        pass
