from enum import Enum
from typing import Type

from xcnt.sqlalchemy.search import fields
from xcnt.sqlalchemy.search.apispec import openapi_type_mixin
from xcnt.sqlalchemy.search.apispec.fields.scalar.base import ScalarFieldConverter


class EnumConverter(openapi_type_mixin.Enum, ScalarFieldConverter[fields.Enum]):
    field_class = fields.Enum

    @property
    def enum(self) -> Type[Enum]:
        return self.item.enum
