from abc import ABC
from typing import Any

from xcnt.sqlalchemy.search.apispec.fields import OpenAPIConverterPlugin
from xcnt.sqlalchemy.search.apispec.fields.scalar.filter.request import FilterRequest
from xcnt.sqlalchemy.search.parser.filter_parser import FilterFieldParser


class BaseFilterConverter(OpenAPIConverterPlugin[FilterRequest], ABC):
    for_list = False

    @classmethod
    def supports(self, entity: Any) -> bool:
        if isinstance(entity, FilterRequest):
            filter_parser = FilterFieldParser.function_mapping.get(entity.filter_name, None)
            if filter_parser is None:
                return False

            return filter_parser.is_listed == self.for_list
        return False
