from abc import ABC, abstractproperty
from typing import Any, Dict, Optional


class BaseTypeMixin(ABC):
    @abstractproperty
    def type_name(self) -> str:
        pass

    @property
    def type_format(self) -> Optional[str]:
        return None

    @property
    def type_dict(self) -> Dict[str, Any]:
        type_dict = {
            "type": self.type_name,
        }
        if self.type_format is not None:
            type_dict["format"] = self.type_format

        return type_dict
