from abc import ABC, abstractproperty
from enum import Enum
from typing import Any, Dict, Type

from xcnt.sqlalchemy.search.apispec.openapi_type_mixin.base import BaseTypeMixin


class EnumTypeMixin(BaseTypeMixin, ABC):
    @abstractproperty
    def enum(self) -> Type[Enum]:
        pass

    @property
    def type_name(self) -> str:
        return "string"

    @property
    def type_dict(self) -> Dict[str, Any]:
        type_dict = super().type_dict
        type_dict["enum"] = [item.value for item in self.enum]
        return type_dict
