from typing import Iterable, Optional, Type, Union

from xcnt.sqlalchemy.search import registry
from xcnt.sqlalchemy.search.query.resource_base import ResourceBase


def resolve_resources(
    resources: Optional[Iterable[Union[Type[ResourceBase], str]]] = None
) -> Iterable[Type[ResourceBase]]:
    if resources is None:
        yield from registry.get_all()
        return

    for resource in resources:
        if isinstance(resource, str):
            yield from registry.get_classes(resource)
        else:
            yield resource
