from abc import ABC
from typing import Any, Iterable, Type

from xcnt.sqlalchemy.search.fields.scalar.base_scalar import FILTER_NAMES
from xcnt.sqlalchemy.search.meta_resolver import find_optional_meta_key


class ScalarFieldGenerator(ABC):
    field_class: Type[Any]

    def supports_filter_function(self, filter_name: str) -> bool:
        return bool(find_optional_meta_key(self.field_class, filter_name, False))

    @property
    def supported_filters(self) -> Iterable[str]:
        return (filter_name for filter_name in FILTER_NAMES if self.supports_filter_function(filter_name))
