from __future__ import annotations

from abc import ABC
from typing import Any, Optional

from xcnt.sqlalchemy.search.meta_resolver import find_meta_key


class BaseField(ABC):
    accepts_non_dict: bool = False

    def __init__(
        self,
        query_field_name: Optional[str] = None,
        attribute_name: Optional[str] = None,
        description: Optional[str] = None,
    ):
        self.query_field_name = query_field_name
        self.name = attribute_name
        self.description = description

    @classmethod
    def meta_key(self, key: str) -> Any:
        return find_meta_key(self, key)
