from abc import ABC, abstractmethod
from typing import Any, Generic, Optional, TypeVar

from xcnt.sqlalchemy.search.fields.table_column_based import TableColumnBased

ConversionTargetType = TypeVar("ConversionTargetType")


class FunctionScalarBase(TableColumnBased, Generic[ConversionTargetType], ABC):
    def convert(self, value: Optional[Any]) -> Optional[ConversionTargetType]:
        if value is None:
            return value

        return self._convert(value)

    @abstractmethod
    def _convert(self, value: Any) -> ConversionTargetType:
        pass
