from __future__ import annotations

from typing import TYPE_CHECKING, Optional, Type, Union

from xcnt.sqlalchemy.search.fields.concrete_base import ConcreteBase

if TYPE_CHECKING:
    from xcnt.sqlalchemy.search.query.resource_having import HavingBaseClass

from xcnt.sqlalchemy.search.fields.abstract_nested_having import AbstractNestedHaving


# Doesn't support annotations configuration, that's why it requires a string
class HavingGroup(ConcreteBase, AbstractNestedHaving["HavingBaseClass"]):
    def __init__(
        self,
        resource: Union[Type[HavingBaseClass], str],
        attribute_name: Optional[str] = None,
        description: Optional[str] = None,
    ):
        super().__init__(resource=resource, attribute_name=attribute_name, description=description)
