from __future__ import annotations

from typing import Optional, Type, Union

from sqlalchemy.ext.declarative import DeclarativeMeta

from xcnt.sqlalchemy.search.fields.concrete_base import ConcreteBase
from xcnt.sqlalchemy.search.fields.nested import Infer, JoinConditionCallable, JoinConditionConfig


class JoinedModel(JoinConditionConfig):
    def __init__(
        self,
        model: DeclarativeMeta,
        wraps: ConcreteBase,
        attribute_name: Optional[str] = None,
        description: Optional[str] = None,
        model_attribute_name: Optional[str] = None,
        join_condition: Union[Type[Infer], JoinConditionCallable] = Infer,
    ):
        self.model = model
        self.wraps = wraps
        super().__init__(
            attribute_name=attribute_name,
            description=description,
            join_condition=join_condition,
            model_attribute_name=model_attribute_name,
        )
