from abc import ABC
from typing import Generic

import pkg_resources

from xcnt.sqlalchemy.search.fields.function_scalar_base import ConversionTargetType, FunctionScalarBase

PLUGIN_ENTRY_POINT = "xcnt.sqlalchemy.search.field.filter"

FILTER_NAMES = tuple(entry_point.name for entry_point in pkg_resources.iter_entry_points(PLUGIN_ENTRY_POINT))

BaseMeta = type(
    "Meta",
    tuple(),
    dict((filter_name, False) for filter_name in FILTER_NAMES),
)


class BaseScalarField(FunctionScalarBase[ConversionTargetType], Generic[ConversionTargetType], ABC):  # type: ignore
    class Meta(BaseMeta):  # type: ignore
        _eq = True
        _neq = True
        _in = True
        _nin = True
