from enum import Enum as EnumClass
from typing import Any, Optional, Type

from xcnt.sqlalchemy.search.fields.scalar.base_scalar import BaseScalarField
from xcnt.sqlalchemy.search.type_conversion import convert_to_enum


class Enum(BaseScalarField[EnumClass]):
    def __init__(self, enum: Type[EnumClass], attribute_name: Optional[str] = None, description: Optional[str] = None):
        super().__init__(attribute_name=attribute_name, description=description)
        self.enum = enum

    def _convert(self, value: Any) -> EnumClass:
        return convert_to_enum(value, self.enum)
