from abc import ABC
from typing import Any, Generic

from xcnt.sqlalchemy.search.fields.scalar.base_scalar import BaseScalarField, ConversionTargetType
from xcnt.sqlalchemy.search.type_conversion import convert_to_string


class StringBaseField(BaseScalarField[ConversionTargetType], Generic[ConversionTargetType], ABC):  # type: ignore
    class Meta:
        _ilike = True
        _like = True


class String(StringBaseField):
    def _convert(self, value: Any) -> str:
        return convert_to_string(value)
