from typing import Generic

from xcnt.sqlalchemy.search.parser.evaluation_result import key_derivations
from xcnt.sqlalchemy.search.parser.resource_base import ResourceBaseQueryType


class AbstractQuery(Generic[ResourceBaseQueryType]):  # type: ignore
    query: ResourceBaseQueryType

    def _get_existing_key(self, key: str) -> str:
        for check_key in key_derivations(key):
            if check_key in self.query:
                return check_key
        raise KeyError(f'Query key "{key}" not found')
