from typing import Any

from sqlalchemy.sql.elements import ClauseElement

from xcnt.sqlalchemy.search.parser.filters.base import BaseFilterParser
from xcnt.sqlalchemy.search.parser.flow_exception import ReturnAll


class BaseIgnoreNullParser(BaseFilterParser):
    def apply(self, value: Any, return_null_values: bool = True) -> ClauseElement:
        if value is None:
            raise ReturnAll()
        return super().apply(value, return_null_values)
