from typing import Any

from sqlalchemy.sql.expression import ClauseElement

from xcnt.sqlalchemy.search.parser.filters.base_ignore_null import BaseIgnoreNullParser
from xcnt.sqlalchemy.search.parser.filters.exception import InvalidSearchData


class ILikeParser(BaseIgnoreNullParser):
    class Meta:
        key = "_ilike"

    def _apply_normalized(self, value: Any) -> ClauseElement:
        return self.model_field.ilike(value)

    def normalize_value(self, value: Any) -> Any:
        value = self.field.convert(value)
        if not isinstance(value, str):
            raise InvalidSearchData("Invalid input for _ilike")
        return value
