from typing import Any

from sqlalchemy.sql.expression import ClauseElement

from xcnt.sqlalchemy.search.parser.filters.base_ignore_null import BaseIgnoreNullParser
from xcnt.sqlalchemy.search.parser.filters.exception import InvalidSearchData


class LikeParser(BaseIgnoreNullParser):
    class Meta:
        key = "_like"

    def _apply_normalized(self, value: Any) -> ClauseElement:
        return self.model_field.like(value)

    def normalize_value(self, value: Any) -> Any:
        value = self.field.convert(value)
        if not isinstance(value, str):
            raise InvalidSearchData("Invalid input for _like")
        return value
