from typing import Any

from sqlalchemy import not_
from sqlalchemy.sql.expression import ClauseElement

from xcnt.sqlalchemy.search.parser.filters.in_ import InParser
from xcnt.sqlalchemy.search.parser.flow_exception import ReturnAll, ReturnNothing


class NotInParser(InParser):
    class Meta:
        key = "_nin"

    def _apply_normalized(self, value: Any) -> ClauseElement:
        try:
            return not_(super()._apply_normalized(value))
        # We negate here the flow exceptions as it should do exactly the opposite to
        # the in query.
        except ReturnAll:
            raise ReturnNothing()
        except ReturnNothing:
            raise ReturnAll()
