from __future__ import annotations

from abc import ABC
from typing import TYPE_CHECKING

from xcnt.sqlalchemy.search.parser.evaluation_result import EvaluationResult, EvaluationResultParser
from xcnt.sqlalchemy.search.parser.resource_reference import ResourceReferenceParserMixin

if TYPE_CHECKING:
    from xcnt.sqlalchemy.search.query import Resource


class KeyedFieldParser(ABC):
    def __init__(self, key: str):
        self.key = key
        super().__init__()


class ResourceKeyedFieldParser(EvaluationResultParser, ResourceReferenceParserMixin, KeyedFieldParser, ABC):
    def __init__(self, key: str, resource: Resource):
        EvaluationResultParser.__init__(self)
        ResourceReferenceParserMixin.__init__(self, resource)
        KeyedFieldParser.__init__(self, key)

    def _result_from_state(self) -> EvaluationResult:
        evaluation_result = super()._result_from_state()
        evaluation_result.key_name = self.key
        return evaluation_result
