from __future__ import annotations

from typing import Any, Mapping

from xcnt.sqlalchemy.search.fields import BaseField
from xcnt.sqlalchemy.search.fields.scalar.base_scalar import BaseScalarField
from xcnt.sqlalchemy.search.parser.filter_parser import FilterFieldParser
from xcnt.sqlalchemy.search.parser.scalar_function import ScalarFunctionFieldParser


class ScalarFieldParser(
    ScalarFunctionFieldParser[BaseScalarField, Mapping[str, Any]], FilterFieldParser[BaseScalarField]
):
    @classmethod
    def supports(cls, entity: BaseField) -> bool:
        return isinstance(entity, BaseScalarField)
