from __future__ import annotations

from abc import ABCMeta
from typing import TYPE_CHECKING, Optional

from xcnt.sqlalchemy.search.fields.concrete_base import ConcreteBase
from xcnt.sqlalchemy.search.parser.evaluation_result import ResultCombination
from xcnt.sqlalchemy.search.query.resource_base import ResourceBase, ResourceBaseMeta

if TYPE_CHECKING:
    from xcnt.sqlalchemy.search.query.resource import Resource


class FieldGroupMeta(ResourceBaseMeta, ABCMeta):
    pass


class FieldGroup(ConcreteBase, ResourceBase, metaclass=FieldGroupMeta):
    class Meta:
        combination: ResultCombination = ResultCombination.AND

    @property
    def _resource_for_fields(self) -> Optional[Resource]:
        return self.resource
