from typing import Callable, Iterable, Optional, Type

import pytest

from xcnt.sqlalchemy.search.api_gateway_crd import Generator, Result
from xcnt.sqlalchemy.search.query.resource_base import ResourceBase
from xcnt.sqlalchemy.search.test import query


@pytest.fixture
def definitions() -> Optional[Iterable[Type[ResourceBase]]]:
    return [query.Component, query.ComponentModel, query.System]


@pytest.fixture
def get_generated_result(definitions) -> Callable[[], Result]:
    generator = Generator(definitions)

    def generate() -> Result:
        return generator.generate()

    return generate
