from typing import Iterable, Optional, Type

import pytest

from xcnt.sqlalchemy.search.query.resource_base import ResourceBase
from xcnt.sqlalchemy.search.test import query


@pytest.fixture
def definitions() -> Optional[Iterable[Type[ResourceBase]]]:
    return [query.QueryFieldNameSystem]


def test_query_field_name(get_generated_result):
    result = get_generated_result()
    resource = result.get_argument_collection("query-field-name-system-query").spec
    assert resource["spec"]["arguments"]["from"]["type"]["scalar"] == "date_time"
    assert resource["spec"]["arguments"]["different_name"]["type"]["argumentCollectionRef"] == "string-query-field"
    assert resource["spec"]["arguments"]["other_name"]["type"]["argumentCollectionRef"] == "string-query-field"
