from apispec import APISpec
from apispec.utils import build_reference

from xcnt.sqlalchemy.search.documentation_generator import SelfReferenceKey
from xcnt.sqlalchemy.search.documentation_generator.uuid_reference_key import UUIDReferenceKey
from xcnt.sqlalchemy.search.test import query


def test_all_functions(api_spec: APISpec, get_parameters) -> None:
    parameter = {"content": {"application/json": {"schema": query.AllFunctions.__name__}}}
    api_spec.components.parameter("where", "query", parameter)
    params = get_parameters()
    schema_reference = params["where"]["content"]["application/json"]["schema"]
    assert schema_reference == build_reference("schema", api_spec.openapi_version.major, query.AllFunctions.__name__)

    components_dict = api_spec.components.to_dict()
    assert query.AllFunctions.__name__ in components_dict["schemas"]
    schema = components_dict["schemas"][query.AllFunctions.__name__]
    # fields, _and and _or, _one_of and _all_of
    expected_size = len(query.AllFunctions()._fields) + len(SelfReferenceKey) + len(UUIDReferenceKey)
    assert len(schema["properties"]) == expected_size
