from typing import Any, Callable, Dict

import pytest
from apispec import APISpec

from xcnt.sqlalchemy.search.apispec import SearchParamPlugin


@pytest.fixture
def api_spec() -> APISpec:
    return APISpec(title="Test", version="1.0.0", openapi_version="3.0.0", plugins=(SearchParamPlugin(),))


@pytest.fixture
def get_parameters(api_spec: APISpec) -> Callable[[], Dict[str, Any]]:
    def _get_parameters() -> Dict[str, Any]:
        return api_spec.to_dict()["components"]["parameters"]

    return _get_parameters
