from apispec import APISpec
from apispec.utils import build_reference

from xcnt.sqlalchemy.search.test import query


def test_query_field_name(api_spec: APISpec, get_parameters) -> None:
    parameter = {"content": {"application/json": {"schema": query.QueryFieldNameSystem.__name__}}}
    api_spec.components.parameter("where", "query", parameter)
    params = get_parameters()
    schema_reference = params["where"]["content"]["application/json"]["schema"]
    assert schema_reference == build_reference(
        "schema", api_spec.openapi_version.major, query.QueryFieldNameSystem.__name__
    )

    components_dict = api_spec.components.to_dict()
    assert query.QueryFieldNameSystem.__name__ in components_dict["schemas"]
    schema = components_dict["schemas"][query.QueryFieldNameSystem.__name__]
    assert schema["properties"]["from"]["type"] == "string"
    assert schema["properties"]["from"]["format"] == "date-time"
    assert schema["properties"]["different_name"]["type"] == "object"
    assert schema["properties"]["other_name"]["type"] == "object"
