from enum import Enum

from xcnt.sqlalchemy.search.meta_resolver import as_metadata_for


class StatusEnum(Enum):
    ACTIVATED = "ACTIVATED"
    DEACTIVATED = "DEACTIVATED"
    ARCHIVED = "ARCHIVED"

    def __str__(self) -> str:
        return self.value


@as_metadata_for(StatusEnum)
class StatusEnumMeta:
    apigateway_name = "status"


class EventLevelEnum(Enum):
    SUCCESS = "SUCCESS"
    INFO = "INFO"
    WARNING = "WARNING"
    ERROR = "ERROR"

    def __str__(self) -> str:
        return self.value
