from uuid import uuid4

import factory

from xcnt.sqlalchemy.search.test.enum import StatusEnum
from xcnt.sqlalchemy.search.test.factories.base import BaseFactory
from xcnt.sqlalchemy.search.test.factories.domain import DomainFactory
from xcnt.sqlalchemy.search.test.model import System


class SystemFactory(BaseFactory):
    class Meta:
        model = System

    name = factory.Sequence(lambda i: f"system{i}")
    alias = factory.Sequence(lambda i: f"system-alias{i}")
    description = factory.Sequence(lambda i: f"description{i}")
    location_uuid = factory.LazyFunction(uuid4)
    domain = factory.SubFactory(DomainFactory)
    status = StatusEnum.ACTIVATED
