from sqlalchemy import Column, ForeignKey, Unicode
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.orm import backref, relationship

from xcnt.sqlalchemy.search.test.model.component_base import ComponentBase
from xcnt.sqlalchemy.search.test.model.component_model import ComponentModel
from xcnt.sqlalchemy.search.test.model.system import System


class Component(ComponentBase):
    __tablename__ = "components"

    code = Column(Unicode)
    system_uuid = Column(UUID(as_uuid=True), ForeignKey("systems.uuid"), index=True)
    component_model_uuid = Column(UUID(as_uuid=True), ForeignKey("component_models.uuid"), nullable=True, index=True)

    system = relationship(System, uselist=False, backref=backref("components", lazy="dynamic", uselist=True))
    component_model = relationship(
        ComponentModel, uselist=False, backref=backref("components", lazy="dynamic", uselist=True)
    )
