from sqlalchemy import Column, Enum, Unicode

from xcnt.sqlalchemy.search.test.enum import StatusEnum
from xcnt.sqlalchemy.search.test.model.base import Base


class ComponentBase(Base):
    __abstract__ = True

    name = Column(Unicode)
    status = Column(
        Enum(*list(item.value for item in StatusEnum), native_enum=False),
        server_default=StatusEnum.ACTIVATED.value,
        nullable=False,
    )
