from sqlalchemy import Column, ForeignKey, Unicode
from sqlalchemy.dialects.postgresql import ENUM, UUID
from sqlalchemy.orm import backref, relationship

from xcnt.sqlalchemy.search.test.enum import StatusEnum
from xcnt.sqlalchemy.search.test.model.base import Base
from xcnt.sqlalchemy.search.test.model.domain import Domain

DBStatusEnum = ENUM(StatusEnum)


class System(Base):
    __tablename__ = "systems"

    alias = Column(Unicode)
    description = Column(Unicode)
    location_uuid = Column(UUID(as_uuid=True))
    domain_uuid = Column(UUID(as_uuid=True), ForeignKey("domains.uuid"), index=True)
    name = Column(Unicode)
    status = Column(DBStatusEnum, server_default=str(StatusEnum.ACTIVATED), nullable=False)
    domain = relationship(Domain, uselist=False, backref=backref("systems", lazy="dynamic", uselist=True))
