from typing import Any

import sqlalchemy
from sqlalchemy.ext.declarative import DeclarativeMeta
from sqlalchemy.sql.elements import ColumnElement

from xcnt.sqlalchemy.search import fields, query
from xcnt.sqlalchemy.search.test.query.all_scalar_values import TestEnum


def sqlalchemy_true(model: DeclarativeMeta, column: ColumnElement, value: Any) -> ColumnElement:
    return sqlalchemy.true()


class AllFunctionsQuery(query.PartialResource):
    class Meta:
        apigateway_entity = "AllFunctions"
        apigateway_role = "WHERE"

    boolean = fields.BooleanFunction(sqlalchemy_true)
    date_time = fields.DateTimeFunction(sqlalchemy_true, description="a datetime")
    date = fields.DateFunction(sqlalchemy_true, description="a date")
    enum = fields.EnumFunction(function=sqlalchemy_true, enum=TestEnum)
    blob = fields.BlobFunction(sqlalchemy_true)
    float = fields.FloatFunction(sqlalchemy_true)
    integer = fields.IntegerFunction(sqlalchemy_true)
    string = fields.StringFunction(sqlalchemy_true)
    time = fields.TimeFunction(sqlalchemy_true)
    timespan = fields.TimespanFunction(sqlalchemy_true)
    uuid = fields.UUIDFunction(sqlalchemy_true)
