from enum import Enum

from xcnt.sqlalchemy.search import fields, query


class TestEnum(Enum):
    A = "A"
    B = "B"


class AllScalarValuesQuery(query.PartialResource):
    class Meta:
        apigateway_entity = "AllValues"
        apigateway_role = "WHERE"

    boolean = fields.Boolean()
    date_time = fields.DateTime(description="a datetime")
    date = fields.Date(description="a date")
    enum = fields.Enum(TestEnum)
    blob = fields.Blob()
    float = fields.Float()
    integer = fields.Integer()
    time = fields.Time()
    uuid = fields.UUID()
    string = fields.String()
