from xcnt.sqlalchemy.search import fields, query
from xcnt.sqlalchemy.search.test.model import DatapointBase


class DatapointQuery(query.Resource):
    class Meta:
        model = DatapointBase
        apigateway_entity = "Datapoint"
        apigateway_role = "WHERE_QUERY"

    float = fields.Float(attribute_name="value_float")
    string = fields.String(attribute_name="value_string")
    blob = fields.Blob(attribute_name="value_blob")
    start = fields.DateTimeFunction((lambda _, column, value: column >= value), attribute_name="time")
    end = fields.DateTimeFunction((lambda _, column, value: column < value), attribute_name="time")
