import gc

import pytest

from xcnt.sqlalchemy.search.query.resource_base import fields_of_items
from xcnt.sqlalchemy.search.test import model, query


@pytest.fixture
def manual_gc():
    gc.disable()
    yield
    gc.enable()


@pytest.mark.usefixtures("manual_gc")
def test_field_removal_on_delete(session):
    def query_fields():
        component_query = query.Component(model.Component)
        assert component_query._fields
        assert component_query in fields_of_items

    gc.collect()
    num_queries = len(fields_of_items)
    query_fields()
    num_queries_after_fields = len(fields_of_items)
    gc.collect()
    num_queries_after_collect = len(fields_of_items)
    assert num_queries + 1 == num_queries_after_fields
    assert num_queries_after_collect == num_queries
