import base64
from typing import Any


def convert_to_blob(value: Any) -> bytes:
    if isinstance(value, str):
        try:
            return base64.b64decode(value)
        except UnicodeDecodeError:
            raise ValueError(f"Cannot convert {value} to blob")
    elif isinstance(value, bytes):
        return value
    else:
        raise ValueError(f"Cannot convert {value} to blob")
