from datetime import date, datetime
from typing import Any


def convert_to_date(value: Any) -> date:
    if isinstance(value, str):
        return date.fromisoformat(value)
    elif isinstance(value, datetime):
        return value.date()
    elif isinstance(value, date):
        return value
    else:
        raise ValueError(f"Cannot convert {value} to date")
