from datetime import datetime
from typing import Any

from dateutil import parser


def convert_to_datetime(value: Any) -> datetime:
    if isinstance(value, str):
        try:
            return datetime.fromisoformat(value)
        except ValueError:
            return parser.parse(value)
    elif isinstance(value, datetime):
        return value
    else:
        raise ValueError(f"Cannot convert {value} to datetime")
