from enum import Enum
from typing import Any, Type, TypeVar

TargetEnum = TypeVar("TargetEnum", bound=Enum)


def convert_to_enum(value: Any, enum_class: Type[TargetEnum]) -> TargetEnum:
    if isinstance(value, str):
        for enum_value in enum_class:
            if enum_value.value.lower() == value.lower():
                return enum_value
    elif isinstance(value, enum_class):
        return value

    valid_values = ", ".join([enum_value.value for enum_value in enum_class])
    raise ValueError(f"Could not convert to valid value. Valid values are: {valid_values}")
