from datetime import datetime, time
from typing import Any


def convert_to_time(value: Any) -> time:
    if isinstance(value, str):
        return time.fromisoformat(value)
    elif isinstance(value, datetime):
        return value.time()
    elif isinstance(value, time):
        return value
    else:
        raise ValueError(f"Cannot convert {value} to time")
